Doomsday Engine - Bug #778

Gamepad usability issues
2009-09-17 16:56 - danij

Status: Progressed Start date: 2007-06-07
Priority: Urgent % Done: 0%
Assignee:

Category: User experience

Target version: Input and game controllers

Description

After hearing several harrowing reports about completely broken joystick/joypad support in Doomsday | decided to pick myself up a
wireless XBOX360 controller to try it out for myself (I had been planning on getting one anyway).

On starting Doomsday | expected that | would at least be able to get feedback from my joypad, however this was not the case. The
only way | could get the joypad to even function was to change the default value of the variable "joydevice" (used with cvar
"input-joy-device") in sys_input.c (Doomsday was defaulting to use device zero (which on this system is the virtual HID for my art
tablet)).

Due to the problem with the config files not being read early enough there is no way to change the joystick/joypad device (obviously
only affects systems with many HIDs but it is very common these days to have more than one (joypad, remote control, external
laptop navpad, game boards...).

Next, | was on to trying the default bindings. Sadly, | was completely unable to start a game without first reconfiguring the controls
and even then | ran into the following issues:

e After binding menu open/close to another button on the joypad | was able to open but not close the menu.

¢ Impossible to bind the POV hat for anything useful (seems that B_BindCommand is deleting all other bindings for the hat when
you create a new one (most likely lacking the angle qualifier)).

¢ Possible to bind the joystick axes for menu navigation but once you do, the menu begins wildly repeating events (seems to be
missing a repeat delay).

¢ Axis position drifting. Regardless of how | configured the deadzone and scale values for a particular axis | could not eliminate
the drifting.

¢ No repeaters for the POV hat.

¢ Lookspring is broken.

¢ Most of the ctl-* cvars no longer work.

¢ Due to the issue with held controls during bind context (de)activation (see here
http://sourceforge.net/tracker/?func=detail&aid=2849414&group_id=74815&atid=542099), most of what should be possible with
the Doomsday binding system is not.

Joystick/joypad support is not looking good atm.

Labels: Controllers

Subtasks:
Feature # 2112: Bindings for the Playstation 3 controller Closed
Feature # 1449: Setup bindings/controls via taskbar Ul Progressed

Related issues:

Related to Feature #1541: Joystick axis settings (sensitivity, max speed) Progressed 2011-06-28
Related to Feature #1229: Input plugins: generate events from connected contr... Rejected 2003-07-09
Related to Feature #1886: Use SDL 2 for window management, display modes, col... In Progress  2014-10-20
Related to Feature #2131: Keyboard navigation Closed 2015-11-23
Related to Feature #2424: Confirm/cancel Y/N questions with game controller Closed 2020-05-10
History

#1 - 2009-09-17 18:26 - danij

Scratch what | said in my last comment. It would seem that the syntax described in comments within the source does not match up with the actual
syntax used.

The POV hat binding issue is caused by B_DeleteMatching not considering the angle when attempting to match existing event bindings. Fixed.
http://sourceforge.net/tracker/?func=detail&aid=2849414&group_id=74815&atid=542099

#2 - 2009-09-17 19:01 - skyjake

(originally posted by anonymous SF.net user)

Any progress on this?

#3 - 2009-09-18 21:51 - danij
The various issues with the POV hat seem to be due to the way the angle is interpreted within the engine. The symbolic event constructor appears to
be returning textual events with a syntax not understood by the bindings system.

e.g:
"joy-hat1-angleQ" is the resultant string from the symbolic echo'd event.
"joy-hat1+angle0" is the syntax the binding system expects (the angle is a condition, not a key/button name)

#4 - 2013-10-22 11:28 - skyjake
- Subject changed from Joystick/Joypad useability issues to Joystick/Joypad usability issues

#5 - 2013-10-22 14:42 - skyjake

- Tags set to Input, Ul, TaskBar, Menu

- Subject changed from Joystick/Joypad usability issues to Joystick/pad usability issues
- Category set to User experience

- Target version changed from 1.9.0-beta6 to 1.14

#6 - 2013-12-25 20:01 - skyjake

- Target version changed from 1.14 to 1.15

#7 - 2014-04-21 13:14 - skyjake

- Target version changed from 1.15 to 42

#8 - 2015-01-16 12:15 - skyjake

- Related to Feature #1886: Use SDL 2 for window management, display modes, color correction, and keyboard/mouse/gamepad input added

#9 - 2015-04-22 05:23 - danij

- Assignee set to danij

#10 - 2015-05-03 17:03 - skyjake

- Target version changed from 42 to 2.0 — Home Ul & Packages

#11 - 2015-06-02 18:36 - rhargrave

| would like to add that | currently have to start doomsday with -nojoy, as | have a custom keyboard controller that doomsday (SDL?) believes is a
joystick. If this is enabled, with the default input settings, my player will do nothing but run in circles.

From looking over the code for the controller (whoever wrote it made a real mess, | need to rewrite it), it does not report itself as being anything other
than an HID keyboard, although it can report itself as a mouse (for mousekeys).

#12 - 2015-09-13 13:44 - skyjake

- Subject changed from Joystick/pad usability issues to Gamepad usability issues

#13 - 2015-11-03 09:21 - skyjake
- Related to deleted (Feature #1449: Setup bindings/controls via taskbar Ul)

#14 - 2015-11-23 22:13 - skyjake
- Related to Feature #2131: Keyboard navigation added

#15 - 2015-11-24 19:34 - skyjake

- Status changed from New to In Progress

#16 - 2016-03-27 08:14 - skyjake

- Target version changed from 2.0 — Home Ul & Packages to Input and game controllers
#17 - 2016-07-06 00:01 - skyjake

- Status changed from In Progress to Progressed

#18 - 2019-11-29 23:06 - skyjake
- Assignee deleted (danij)

#19 - 2020-05-10 07:15 - jonesmz

| tried my Wireless XBox One controller with the 2.2 release, and everything is working great there except there's no way to use the controller to exit
the game, and no way to bring up the Doomsday Engine taskbar.

With Doom 2, if you use the menu button, and select quit, with the controller, you're still required to press Y/N on the keyboard to exit.

#20 - 2020-05-10 11:09 - skyjake
- % Done changed from 55 to 0

jonesmz wrote:

there's no way to use the controller to exit the game, and no way to bring up the Doomsday Engine taskbar.

| added #2424 to address the Y/N response. This is easy to fix by adding a couple of bindings.
You can currently go to the Controls menu and bind game controller keys for these manually (in the end of the list).

I'll add a Show Taskbar control to the menu so it can be bound manually, too.

#21 - 2020-05-10 11:10 - skyjake

- Related to Feature #2424: Confirm/cancel Y/N questions with game controller added

2024-04-17 3/3


https://tracker.dengine.net/issues/2424
http://www.tcpdf.org

